%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%{!?python_sitearch: %define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}
%global has_isa %{!?_isa:0}%{?_isa:1}
%global POLICYCOREUTILSVER 1.33.12-14.8
%global gettext_domain ipa

Name:           ipa-client
Version:        2.1.3
Release:        2%{?date}%{?dist}
Summary:        IPA authentication for use on clients

Group:          System Environment/Base
License:        GPLv3+
URL:            http://www.freeipa.org/
Source0:        http://www.freeipa.org/downloads/src/freeipa-%{version}.tar.gz
Patch1:         ipa-client-install.patch
Patch2:         ipa-python24.patch
Patch3:         ipa-client-kinit.patch
Patch4:         ipa-openldap.patch
Patch5:         freeipa-refer.patch
Patch6:         freeipa-getkeys.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  openldap-devel
BuildRequires:  krb5-devel
BuildRequires:  python-devel
BuildRequires:  python-setuptools
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  libtool
BuildRequires:  popt
BuildRequires:  m4
BuildRequires:  xmlrpc-c-devel >= 1.16.24-1206.1840
BuildRequires:  curl-devel >= 7.15.5-9
BuildRequires:  gettext
BuildRequires:  authconfig

Requires: python-ldap
# _isa is not defined in RHEL-5 so fall back to per-arch
%if %{has_isa}
Requires: cyrus-sasl-gssapi%{_isa}
%else
%ifarch x86_64 ppc64 s390x ia64
Requires: libgssapiv2.so.2()(64bit)
%else
Requires: libgssapiv2.so.2
%endif # 64-bit
%endif # _isa
Requires: ntp
Requires: krb5-workstation
Requires: authconfig >= 5.3.21-7
Requires: pam_krb5
Requires: wget
Requires: certmonger
Requires: xmlrpc-c >= 1.16.24-1206.1840.el5_7.3
Requires: curl >= 7.15.5-9.el5_7.4
Requires: policycoreutils >= %{POLICYCOREUTILSVER}
Requires: nss-tools
Requires: openssl >= 0.9.8e-18
Requires: sssd >= 1.5.1-40
Requires: bind-utils

%description
IPA is an integrated solution to provide centrally managed Identity (machine,
user, virtual machines, groups, authentication credentials), Policy
(configuration settings, access control information) and Audit (events,
logs, analysis thereof).

%prep
%setup -n freeipa-%{version} -q
%patch1 -p1 -b .ipa-client
%patch2 -p1 -b .python24
%patch3 -p1 -b .kinit
%patch4 -p1 -b .openldap
%patch5 -p1 -b .refer
%patch6 -p1 -b .getkeys

# RHEL 5 uses an old libtool, so we need to reconfigure
for i in libtool ltmain.sh aclocal.m4 libtool.m4  lt~obsolete.m4  ltoptions.m4  ltsugar.m4  ltversion.m4
do
    find . -name $i -exec rm -f {} \;
done
# reconfigure done in build step

%build
export CFLAGS="$CFLAGS %{optflags}"
export CPPFLAGS="$CPPFLAGS %{optflags}"
make version-update SKIP_API_VERSION_CHECK=yes
cd ipa-client; ../autogen.sh --prefix=%{_usr} --sysconfdir=%{_sysconfdir} --localstatedir=%{_localstatedir} --libdir=%{_libdir} --mandir=%{_mandir} --with-openldap; cd ..

make IPA_VERSION_IS_GIT_SNAPSHOT=no %{?_smp_mflags} SKIP_API_VERSION_CHECK=yes client 
cd selinux

%install
rm -rf %{buildroot}
make client-install SKIP_API_VERSION_CHECK=yes DESTDIR=%{buildroot} 

mkdir -p %{buildroot}/%{_localstatedir}/lib/ipa-client/sysrestore

# Undo the ipa-python install and copy the files we need
mkdir %{buildroot}/%{python_sitelib}/ipaclient/ipapython
mkdir %{buildroot}/%{python_sitelib}/ipaclient/ipapython/platform
mv %{buildroot}/%{python_sitelib}/ipapython/sysrestore.* %{buildroot}/%{python_sitelib}/ipaclient/ipapython 
mv %{buildroot}/%{python_sitelib}/ipapython/ipautil.* %{buildroot}/%{python_sitelib}/ipaclient/ipapython 
mv %{buildroot}/%{python_sitelib}/ipapython/version.* %{buildroot}/%{python_sitelib}/ipaclient/ipapython 
mv %{buildroot}/%{python_sitelib}/ipapython/dnsclient.* %{buildroot}/%{python_sitelib}/ipaclient/ipapython 
mv %{buildroot}/%{python_sitelib}/ipapython/ipavalidate.* %{buildroot}/%{python_sitelib}/ipaclient/ipapython 
mv %{buildroot}/%{python_sitelib}/ipapython/config.* %{buildroot}/%{python_sitelib}/ipaclient/ipapython 
mv %{buildroot}/%{python_sitelib}/ipapython/certmonger.* %{buildroot}/%{python_sitelib}/ipaclient/ipapython 
mv %{buildroot}/%{python_sitelib}/ipapython/__init__.* %{buildroot}/%{python_sitelib}/ipaclient/ipapython 
mv %{buildroot}/%{python_sitelib}/ipapython/services.* %{buildroot}/%{python_sitelib}/ipaclient/ipapython 
mv %{buildroot}/%{python_sitelib}/ipapython/platform/* %{buildroot}/%{python_sitelib}/ipaclient/ipapython/platform

rm -rf %{buildroot}/%{python_sitelib}/ipapython
rm -rf %{buildroot}/%{python_sitelib}/ipalib
rm -rf %{buildroot}/%{python_sitelib}/*.egg-info
rm -f %{buildroot}/%{python_sitearch}/default_encoding_utf8.so

# So we can own our configuration file
mkdir -p %{buildroot}/%{_sysconfdir}/ipa
/bin/touch %{buildroot}/%{_sysconfdir}/ipa/default.conf

%clean
rm -rf %{buildroot}


%files
%defattr(-,root,root,-)
%doc COPYING README
%{_sbindir}/ipa-client-install
%{_sbindir}/ipa-getkeytab
%{_sbindir}/ipa-rmkeytab
%{_sbindir}/ipa-join
%dir %{_usr}/share/ipa
%dir %{_usr}/share/ipa/ipaclient
%dir %{_localstatedir}/lib/ipa-client
%dir %{_localstatedir}/lib/ipa-client/sysrestore
%{_usr}/share/ipa/ipaclient/ipa.cfg
%{_usr}/share/ipa/ipaclient/ipa.js
%dir %{python_sitelib}/ipaclient
%dir %{python_sitelib}/ipaclient/ipapython
%dir %{python_sitelib}/ipaclient/ipapython/platform
%{python_sitelib}/ipaclient/*.py*
%{python_sitelib}/ipaclient/ipapython/*.py*
%{python_sitelib}/ipaclient/ipapython/platform/*.py*
%{_mandir}/man1/ipa-getkeytab.1.gz
%{_mandir}/man1/ipa-rmkeytab.1.gz
%{_mandir}/man1/ipa-client-install.1.gz
%{_mandir}/man1/ipa-join.1.gz
%{_mandir}/man5/default.conf.5.gz
%ghost %config(noreplace) %{_sysconfdir}/ipa/default.conf

%changelog
* Thu Dec 10 2012 Eddy Nigg <eddy_nigg@startcom.org>
- Rebuild for StartCom Linux 5.0.x

* Tue May  1 2012 Rob Crittenden <rcritten@redhat.com> - 2.1.3-2
- Only warn if ipa-getkeytab doesn't get all requested enctypes. (#818313)

* Thu Nov 10 2011 Rob Crittenden <rcritten@redhat.com> - 2.1.3-1
- Rebase to upstream 2.1.3 (#753936)
- Updated patch for CVE-2011-3636 to include CR in the HTTP headers.
  xmlrpc-c in RHEL-6 doesn't support the dont_advertise option so that is
  not set any more. Another fake header, X-Original-User_Agent, is added
  so there is no more trailing junk after the Referer header.  (#752226)
- Add ia64 to list for 64-bit cyrus-sasl-gssapi (#750338)
- Set minimum n-v-r of sssd to 1.5.1-40

* Thu Sep 22 2011 Rob Crittenden <rcritten@redhat.com> - 2.0-19
- Don't log the OTP in the client install log (#739068)

* Wed Sep  7 2011 Rob Crittenden <rcritten@redhat.com> - 2.0-18
- Create a separate boolean, has_ipa, to test for existence of
  _ipa. (#723620).

* Wed Sep  7 2011 Rob Crittenden <rcritten@redhat.com> - 2.0-17
- Fix rpmdiff problem with undefined _isa (#723620).

* Tue Sep  6 2011 Rob Crittenden <rcritten@redhat.com> - 2.0-16
- _isa is not defined in RHEL 5, use alternate mechanism to require
  arch-specific cyrus-sasl-gssapi (#723620)

* Wed Aug 17 2011 Rob Crittenden <rcritten@redhat.com> - 2.0-15
- KDC autodiscovery may fail when domain != realm (#710143)
- Use updated xmlrpc-c API to do GSSAPI ticket delegation (#723667)
- Set minimum curl and xmlrpc-c versions (#723667)
- Require arch-specific cyrus-sasl-gssapi (#723620)

* Thu May 12 2011 Rob Crittenden <rcritten@redhat.com> - 2.0-14
- Remove hardcoded path to kinit (#704235)

* Wed Mar 23 2011 Rob Crittenden <rcritten@redhat.com> - 2.0-13
- Add BuildRequires for authconfig

* Wed Mar 23 2011 Rob Crittenden <rcritten@redhat.com> - 2.0-12
- Update to upstream 2.0.0rc3 (#631907)
- Add patch to work on Python 2.4
- Set minimum Requires for authconfig to 5.3.21-7 (sssd support)
- Set minimum Requires for openssl to 0.9.8e-18 (sha2 support)
- Add Requires for sssd, set minimum to sssd-1.5.1-18
- Add Requires for bind-utils
- Remove Requires on nss_ldap
- Update license to GPLv3+

* Thu Mar 10 2011 Rob Crittenden <rcritten@redhat.com> - 2.0-11
- Fix OID for join and ipa-getkeytab operation (#682231)

* Fri Aug 27 2010 Rob Crittenden <rcritten@redhat.com> - 2.0-10
- Port to RHEL-5 (#607772)
- Drop nslcd patch
- Drop move binaries patch
- authconfig 6.0 isn't available so we can't automatically configure sssd
  so configure nss_ldap instead

* Tue Jun 22 2010 Rob Crittenden <rcritten@redhat.com> - 2.0-9
- Add /etc/pam_ldap.conf to the list of files we update (#559004)

* Thu Jun  3 2010 Rob Crittenden <rcritten@redhat.com> - 2.0-8
- Re-add patch to attempt to configure a number of nss_ldap related files
  if installed and configure nslcd.conf if installed. This got inadvertantly
  dropped when the source tarball was re-based (#559004)
- Update nokrbv patch to remove another usage of python-krbV that
  isn't directly used by ipa-client but fails at runtime. (#598626)

* Thu Jun  3 2010 Rob Crittenden <rcritten@redhat.com> - 2.0-7
- Update nokrbv patch to remove another usage of python-krbV that
  isn't directly used by ipa-client but fails the build. (#598626)

* Thu Jun  3 2010 Rob Crittenden <rcritten@redhat.com> - 2.0-6
- Remove dependency on python-krbV package (#598626)

* Mon May 10 2010 Rob Crittenden <rcritten@redhat.com> - 2.0-5
- Add gettext as a BuildRequires (#556620)

* Thu May  6 2010 Rob Crittenden <rcritten@redhat.com> - 2.0-4
- Update source tarball to freeIPA v2.0 alpha 3 (tag 1.9.0_alpha3) (#556620)
- More spec file clean ups
- Don't install the po files so it doesn't conflict with the server
  ipa-python package

* Fri Feb 19 2010 Rob Crittenden <rcritten@redhat.com> - 2.0-3
- Remove explicit requires on krb5-libs (#556620)

* Wed Jan 27 2010 Rob Crittenden <rcritten@redhat.com> - 2.0-2
- Remove some commented-out Requires
- Replace Requires on nss_ldap with nss-pam-ldapd (#559004)
- Add patch to attempt to configure a number of nss_ldap related files
  if installed and configure nslcd.conf if installed (#559004)

* Wed Dec  2 2009 Rob Crittenden <rcritten@redhat.com> - 2.0-1
- Initial spec
- policycoreutils version set to 2.0.78-3 to fix problem with
  restorecon returning 1 in non-failure cases.
